godot-demo-projects/format.sh

45 lines
1.3 KiB
Bash
Raw Normal View History

#!/usr/bin/env bash
set -uo pipefail
IFS=$'\n\t'
2020-03-19 23:36:55 +01:00
# Loops through all text files tracked by Git.
git grep -zIl '' |
while IFS= read -rd '' f; do
# Exclude csproj and hdr files.
if [[ "$f" == *"csproj" ]]; then
2020-03-19 23:36:55 +01:00
continue
elif [[ "$f" == *"hdr" ]]; then
2020-03-19 23:36:55 +01:00
continue
fi
# Ensures that files are UTF-8 formatted.
recode UTF-8 "$f" 2> /dev/null
2020-03-19 23:36:55 +01:00
# Ensures that files have LF line endings.
dos2unix "$f" 2> /dev/null
2020-03-19 23:36:55 +01:00
# Ensures that files do not contain a BOM.
sed -i '1s/^\xEF\xBB\xBF//' "$f"
# Ensures that files end with newline characters.
tail -c1 < "$f" | read -r _ || echo >> "$f";
# Remove trailing space characters.
sed -z -i 's/\x20\x0A/\x0A/g' "$f"
2020-03-19 23:36:55 +01:00
done
git diff > patch.patch
FILESIZE="$(stat -c%s patch.patch)"
2020-03-19 23:36:55 +01:00
MAXSIZE=5
# If no patch has been generated all is OK, clean up, and exit.
if (( FILESIZE < MAXSIZE )); then
printf "Files in this commit comply with the formatting rules.\n"
rm -f patch.patch
exit 0
fi
# A patch has been created, notify the user, clean up, and exit.
printf "\n*** The following differences were found between the code "
printf "and the formatting rules:\n\n"
cat patch.patch
printf "\n*** Aborting, please fix your commit(s) with 'git commit --amend' or 'git rebase -i <hash>'\n"
rm -f patch.patch
exit 1